
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef SERVICE_TYPES_H
#define SERVICE_TYPES_H

#include "initng_list.h"
#include "initng_active_db.h"

/* service types struct */
typedef struct
{
    /* Name of servicetype */
    const char *name;

    /* Called to start service */
    int (*start_service) (active_h * service);

    /* Called to stop service */
    int (*stop_service) (active_h * service);

    /* Called to restart service */
    int (*restart_service) (active_h * service);

    /* list of stypes */
    struct list_head list;
} stype_h;

#define stype_add(st) list_add(&(st)->list, &g.stypes.list)
#define stype_del(st) list_del(&(st)->list)
/* service_db walker */
#define while_stypes(current) list_for_each_entry_prev(current, &g.stypes.list, list)
#define while_stypes_safe(current, safe) list_for_each_entry_prev_safe(current, safe, &g.stypes.list, list)

#endif
