
/* Initng, a next generation sysvinit replacement.
 * Copyright (C) 2005 Jimmy Wennlund <jimmy.wennlund@gmail.com>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General
 * Public License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#include <stdlib.h>
#include <stdio.h>
#include "initng_active_db.h"
#include "initng_static_data_id.h"
#include "initng_service_data_types.h"

/*
 * Here is where we define, the default options, and
 * relate to, by pointers
 * 
 * Description:
 * { "name_of_opt", TYPE_OF_OPT, STRING_LEN_OF("name_of_opt") }
 */
s_entry USE = { "use", STRINGS, 3, NULL,
    "Need to be up if they are in this runlevel."
};
s_entry NEED =
    { "need", STRINGS, 4, NULL, "Need to be up, ignore if not found." };
s_entry REQUIRE =
    { "require", STRINGS, 7, NULL, "Need to be up, fail if not found." };
s_entry FROM_FILE = { "from_file", STRING, 0, NULL, NULL };
s_entry ENV = { "env", STRINGS, 3, NULL, "Sets an enviromental variable." };
s_entry RESTARTING = { NULL, SET, 0, NULL, NULL };
s_entry UP_ON_FAILURE = { "up_on_failure", SET, 13, NULL,
    "Mark this service as up, even if it fails to start."
};
s_entry STOP_TIMEOUT = { "stop_timeout", INT, 12, NULL,
    "Wait this seconds, before hard-terminate a stopping daemon."
};

/*
 * add some default options, that is needed by core, and shud
 * be in option_db by default.
 * This function is called, from main(), initziation.
 */
void initng_sdt_add_defaults(void)
{
    initng_sdt_add(&USE);
    initng_sdt_add(&NEED);
    initng_sdt_add(&REQUIRE);
    initng_sdt_add(&FROM_FILE);
    initng_sdt_add(&ENV);

    initng_sdt_add(&RESTARTING);

    initng_sdt_add(&STOP_TIMEOUT);
}
