#!/bin/bash

function compare_files()
{
    distro=$1
    test_file=$2
    $INSTALL_SERVICE -d $1 -i $test_file.ii -o $test_file-$distro-out.i 2>/dev/null
    input=$(md5sum $test_file-$distro.i | cut -f1 -d ' ')
    output=$(md5sum $test_file-$distro-out.i | cut -f1 -d ' ')
    if [ $input != $output ]
    then
	echo "* Failed $test_file for distro $distro."
    fi
}

function test_all()
{
    compare_files fedora test01
    compare_files debian test01
    compare_files unknown test01

    compare_files fedora test02
    compare_files debian test02
    compare_files gentoo test02
    compare_files unknown test02
}

echo "Testing install_service.pl"
INSTALL_SERVICE="../../tools/install_service.pl"
test_all

echo "Testing original install_service"
INSTALL_SERVICE="../../tools/install_service"
test_all


